#!/bin/bash

# Logging variables
LOGS_FOLDER="logs"
LOGS_FILE="logs.txt"
LOGGER_SCRIPT="logger.sh"
PROGNAME="user_management"
BASE_PATH="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# Naming prefixes
 USR_DB_PREFIX="usr"

. $BASE_PATH/global_conf.config

source $BASE_PATH/$LOGGER_SCRIPT -l $LOGS_FOLDER$LOGS_FILE -f $PROGNAME -e "DEBUG"
OPTIND=1

source $BASE_PATH/appFramework.sh

OPTIND=1


function usage(){
    echo "createU -h for help, -u [username] for new user";exit 0;
}

while getopts ":h:u:" opt; do
    case "${opt}" in
    	h) usage;;
    	u) username=${OPTARG};;
	    *) usage;;
    esac
done
OPTIND=1


if [[ ! -z $username ]]
    then
    createDatabase ${USR_DB_PREFIX}_${username} &&
    makeUserHome $username &&
    createUserFolder $username &&
    createRole $username || {
		    ERRORT "Operations failed";
			  exit 1;
		}
		generatePrivateKey $username || {
			ERRORT "private key generation for user ${username} has failed, exiting script";
			exit 1;
		}
		INFOT "success"
		exit 0;

    else
        ERRORT "Username parameter required!"; exit 1
fi
