#!/bin/bash

LOGS_FOLDER="logs"
LOGS_FILE="logs.txt"
LOGGER_SCRIPT="logger.sh"
PROGNAME="user_management"
BASE_PATH="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

. $BASE_PATH/global_conf.config

source $BASE_PATH/$LOGGER_SCRIPT -l $LOGS_FOLDER$LOGS_FILE -f $PROGNAME -e "DEBUG"
OPTIND=1

source $BASE_PATH/appFramework.sh

OPTIND=1

function usage(){
    echo "createWorkspace -h for help, -n [name] for workspace name, -d for source dependencies file";exit 0;
}


while getopts ":h:n:d:" opt; do
    case "${opt}" in
    	h)
            usage
            ;;
    	n)  workspaceName=${OPTARG}
            ;;
        d)  dependencies=${OPTARG}
            ;;

	*)
	    usage
	    ;;
    esac
done

OPTIND=1




if [[ ! -z $workspaceName ]]
    then

		kinitForCreateOps

        #transform workspace name to lowercase
		workspaceName=$( echo "${workspaceName}" | awk '{print tolower($0)}' )



		workspaceFolder="/appl/wsp_${workspaceName}"
		createWorkspaceLinuxFolder ${workspaceFolder} $workspaceName "group" &&
		createWorkspaceHDFSFolder $workspaceName $workspaceFolder "group" &&
		createDatabase $workspaceName &&
		createRole $workspaceName "wsp" &&
		setQuota $workspaceFolder 1000 || {
			ERRORT "Some operation has failed";
			exit 1;
		}


		INFOT "success";

	else
		ERRORT "insufficient number of parameters, type -h for help"

fi
