import logging
import logging.handlers
import sys


def configure_logging():
    logger = logging.getLogger('workspace')
    logger.setLevel(logging.DEBUG)
    formatter = logging.Formatter("[%(asctime)s] %(levelname)s [%(process)d %(name)s.%(funcName)s:%(lineno)d] "
                                      "%(message)s")
    fh = logging.handlers.RotatingFileHandler(
        "user_management.out", maxBytes=20000, backupCount=1)

    # fh = logging.FileHandler("retention.log")
    fh.setLevel(logging.DEBUG)
    # create console handler with a higher log level
    ch = logging.StreamHandler(sys.stdout)
    ch.setLevel(logging.INFO)

    ch.setFormatter(formatter)
    fh.setFormatter(formatter)

    # add the handlers to the logger
    logger.addHandler(fh)
    logger.addHandler(ch)
