import subprocess
from sqlQueries import SqlQueries
import logging
from log import configure_logging


class LinuxCheck:

    def __init__(self):
        self.sqlQueries = SqlQueries()
        self._logger = logging.getLogger("workspace.run")
        self.nodes = ["worker1", "worker2"]
        self.env = "prod"

    configure_logging()

    def check_workspaces(self):
        workspaces = self.sqlQueries.get_group_workspaces_to_check()
        if len(workspaces) == 0:
            exit(55)
        for workspace in workspaces:

            users_in_workspace = self.sqlQueries.get_users_in_workspace(workspace)
            for user in users_in_workspace:
                self._logger.info(user)
                group = self.sqlQueries.get_users_workspace_group(workspace, user)
                for grp in group:
                    if self.user_is_in_group(user, grp):
                        self.sqlQueries.set_workspace_is_ready(workspace)
                    else:
                        self._logger.info("{} not ready".format(workspace))
                        pass


            # workspace_groups = self.sqlQueries.get_workspace_groups(workspace)
            # user

    def user_is_in_group(self, user, group):
        users_in_group = self.get_users_in_group(group)
        if user in users_in_group:
            return True
        else:
            return False

    def get_users_in_group(self, group):
        cmd = "getent group {} | awk -F: '{}'".format(group, "{print $4}")
        output = self.execute_linux_command(cmd).split(",")
        output[-1] = output[-1].strip()
        print(output)
        return output

    @classmethod
    def execute_linux_command(cls, cmd):
        ps = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
        result = ps.communicate()[0]
        return result



    # create Workspaces
    def create_workspaces(self):
        workspaces = self.sqlQueries.get_prepared_workspaces()
        for workspace in workspaces:
            self.run_script("/var/www/html/um/bashScripts/createWorkspace.sh -n {}".format(workspace))



    # Run Shell script
    def run_script(self, cmd):
        ps = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
        ps.communicate()


def run_script(cmd):
    ps = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    result = ps.communicate()[0]
    return result.splitlines()

test = LinuxCheck()
test.create_workspaces()
# test.check_workspaces()











